/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package rootgui;

import java.awt.HeadlessException;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.event.WindowStateListener;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.SwingUtilities;
import javax.swing.WindowConstants;
//import javax.swing.UIManager;
//import javax.swing.UnsupportedLookAndFeelException;

import rootgui.model.VRootModel;
import rootgui.controller.VRootController;
import rootgui.view.DisplayViewFrame;
import rootgui.view.IConsoleOutput;
import visualiser.*;

import simserver.*;

/**
 * 
 * @author tghetiu
 */
public class RootGUI {
	
//	private final String SERVER_NAME = "localhost";
//	private final String SERVER_NAME = "128.243.111.12";

	
	private AbsSimServerClient ssc;
	private IVisualiser vis;
	private VRootController controller;
	private VRootModel vrModel;
	private DisplayViewFrame dvf;

	/** Creates a new instance of Main */
	public RootGUI() {
		// * The Nimbus look and feel
//		try {
//
//			for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
//				if ("Nimbus".equals(info.getName())) {
//					javax.swing.UIManager.setLookAndFeel(info.getClassName());
//					break;
//				}
//			}
//
//		} catch (Exception ex) {
//			// java.util.logging.Logger.getLogger(dvf.class.getName()).log(java.util.logging.Level.SEVERE,
//			// null, ex);
//		}

		try {
			//TODO show splash screen?
			
			vrModel = new VRootModel();
			
			controller = new VRootController();
//			controller.setServerName("localhost");
			controller.setModel(vrModel);			
			
			// initialise visualisation MVC
			vis = new Visualiser(vrModel, controller);
			dvf = new DisplayViewFrame(controller, vis);
			vis.setConsoleOutput(dvf);
			vis.addViewPanelActionListener(dvf);
			vis.addVisualiserActionListener(dvf);

			controller.addView(dvf);
			controller.setConsoleOutput(dvf);
			
			// build main frame
			JFrame frame = new JFrame("SimuPlant: The Virtual Root");
			frame.add(dvf);
			JMenuBar jmb = new JMenuBar();
			frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
			frame.addWindowListener(new WindowListener() {

				@Override
				public void windowOpened(WindowEvent e) {
				}
				@Override
				public void windowIconified(WindowEvent e) {
				}
				@Override
				public void windowDeiconified(WindowEvent e) {
				}
				@Override
				public void windowDeactivated(WindowEvent e) {
				}
				@Override
				public void windowClosing(WindowEvent e) {
					try {
						new Thread(new Runnable() {
							
							@Override
							public void run() {
								controller.removeView(dvf);
								dvf.destroy();
								controller.removeAllSimulationRuns();															
							}
						}).start();
					} catch (Exception e1) {
						e1.printStackTrace();
					}
				}
				@Override
				public void windowClosed(WindowEvent e) {
				}
				@Override
				public void windowActivated(WindowEvent e) {
				}
			});
			for (JMenu menu : dvf.getMenus())
				jmb.add(menu);
			frame.setJMenuBar(jmb);
			frame.pack();			
			//
			vis.addVisualiserTab(null);
			frame.setVisible(true);
		} catch (HeadlessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * @param args
	 *            the command line arguments
	 */
	public static void main(String[] args) {
		// TODO code application logic here
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				// Turn off metal's use of bold fonts
				// UIManager.put("swing.boldMetal", Boolean.FALSE);
				new RootGUI();
			}
		});
	}
}
