package rootgui.model.objects;

import java.io.Serializable;


/**
 *  Basically the same as java.awt.Point
 */
public class Point implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 2776286260900205758L;

	private int x,y;
	
	public Point (int x, int y) {
		this.x=x;
		this.y=y;
	}
	
	public int getX() {
		return x;	
	}
	
	public int getY() {
		return y;
	}
	
	public void setX(int x){
		this.x = x;
	}

	public void incX(int x){
		this.x += x;
	}

	public void setY(int y){
		this.y = y;
	}

	public void incY(int y){
		this.y += y;
	}

	@Override
	public int hashCode() {
		
		return x-y;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof Point) {
			Point o=(Point) obj;
			return this.x==o.x && this.y==o.y;
		} else {
			return false;
		}
	}
	
	@Override
	public String toString() {
		return String.format("(%d,%d)", x,y);
	}
}
