package rootgui.model.recordstore;

import java.io.Serializable;

import rootgui.model.SimulationRun;
import rootgui.model.objects.Species;

/*
 * Interface concerning data-related operations
 */
public interface IRecordStore extends Serializable {

	/*
	 * Returns the number of records within the record store
	 */
	public int size();

	/*
	 * Appends a record to the record store
	 */
	public void addRecord(Record r);

	/*
	 * 
	 */
	public Record updateRecord(Record r);

	/*
	 * 
	 */
	public Record getRecord(int iteration);

	public SimulationRun getSimulationRun();
	
	public int getSimID();
	/*
	 * 
	 */
	public void removeRecord(int iteration);

	public void removeRecordsStartingFrom(int startingIteration);

	public SpeciesRecord getSpeciesRecord(Species species, int iteration);

	/*
	 * 
	 */
	public void clear();

	/*
	 * Loads an initial CellSet geometry file
	 */
	public int setGeometry(String xmlFile, int iteration);

	public void fireRecordAdded(int iteration);

	public void fireRecordDeleted(int iteration);

	public void fireRecordUpdated(int iteration);
	
	public void fireCellDataUpdated(Record r, String cellID, String speciesName, double value);

	public void addListener(RecordStoreActionListener l);

	public void removeListener(RecordStoreActionListener l);
}
