package rootgui.view;

import java.util.List;

import javax.swing.JMenu;
import javax.swing.JPanel;

import rootgui.controller.RunnableBlockingQueueListActionListener;
import rootgui.model.TabPropertyChangeEvent;

public abstract class AbstractViewFrame extends JPanel implements IConsoleOutput, RunnableBlockingQueueListActionListener {
    
    /**
     * Called by the controller when it needs to pass along a property change 
     * from a model.
     *
     * @param evt The property change event from the model
     */
    
    public abstract void modelPropertyChange(TabPropertyChangeEvent evt);    

    /*
     * Returns a List of menus (JMenu) to be set in a JMenuBar
     */
    public abstract List<JMenu> getMenus();
    
    public abstract void destroy();
}
