package rootgui.view.settingspanel;

import rootgui.model.Parameter;
import rootgui.model.objects.SimulationModel;

/**
 * Default action listener
 */
public interface DefaultSettingsPanelActionListener {

	/*
	 * The Set model button was pressed
	 */
	public void fireSetButtonPressed(SimulationModel model);
	
	/*
	 * The Initialise Simulation button was pressed
	 */
	public void fireInitSimButtonPressed();
	
	/**
	 * Called when another geometry(tissue) file is selected
	 * @param geometryFileName, name of the geometry file
	 */
	public void fireGeometryChanged(final String geometryFileName);

	/**
	 * Called when a parameter is modified through the settings panel
	 * @param modelName, to which the parameter belongs
	 * @param param, the parameter
	 */
	public void fireParameterChanged(String modelName,  Parameter param);	
}
