package visualiser.viewpanel.view;

import visualiser.Figure;
import visualiser.viewpanel.controller.CDPController;
import rootgui.model.*;
import rootgui.model.objects.Species;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class FrameDemo extends JFrame {

	CellDrawingPanel drawingPanel;
	JScrollPane spane;

	public FrameDemo() {
		// Create and set up the window.
		setTitle("Frame Demo");

		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		AbstractModel model = new VRootModel();
		try {
//			model.readGeometryFromFile("src/Data/geometry.xml");
//			model.readSpeciesFromFile(new Species("DII", Species.Type.CELL), "src/Data/DII_cell_oncentrations.csv");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		Figure f = new Figure(new Species("DII", "DII-VENUS", Species.Type.CELL), 0, 100);
		drawingPanel = new CellDrawingPanel(0, f, 0);

		CDPController controller = new CDPController(null, model, drawingPanel);

		drawingPanel.setController(controller);

		drawingPanel.setPreferredSize(new Dimension(1000, 700));
		spane = new JScrollPane(drawingPanel);
		getContentPane().add(spane, BorderLayout.CENTER);

		setSize(1000, 600);
		setVisible(true);
	}

	public static void main(String[] args) {

		FrameDemo frame = new FrameDemo();
	}

}
